local _, class = UnitClass("player")

---------------------------------------------------
-- standard configuration
---------------------------------------------------
whoaUnitFrames = {}
whoaUnitFrames.config = {
    classColor = true,              -- true or false
    repositionPartyText = true,     -- true or false
    largeAuraSize = 27,             -- Blizzard default value is 21
    smallAuraSize = 21,             -- Blizzard default value is 17
    customStatusText = true,        -- true or false (If this is false, all following points receive no consideration!)
    autoManaPercent = true,         -- true or false (If this is true, percentages where shown for mana classes!)
    thousandSeparators = true,      -- true or false
    simpleHealth = true,            -- rounds healthpoints over 199.999 (200.000 to 200 k, 3.000.000 to 3 m)
    showMaxHealth = false,          -- true or false - show the maximum healthpoints - unnecessary imo, but someone asked for that feature ;)
    scale = 1.0,                    -- scaling for Focus-, Player- and TargetFrame
--    oocTransparency = 1.0,          -- This parameter is by default off because it can increase the problems with the ToT frame. - out of combat transparency (1.0 standard value, 0.5 would be 50% transparency)
	petFrameOnTop = false,           -- true or false - Shows the PetFrame above the PlayerFrame.
	hitIndicators = false,          -- true or false - Do you wanna see the hitindicators on PlayerFrame and PetFrame?
	showToTName = false,            -- true or false - Shows the Name of the ToT beside your TargetFrame.
}

whoaUnitFrames.config.phrases = {
    ["1000 separator"] = " ",
    ["Dead"] = "|cFFFFFFFFDead|r",
    ["Ghost"] = "|cFFFFFFFFGhost|r",
    ["Offline"] = "|cFFFFFFFFOffline|r",
    ["kilo"] = " k",  -- simpleHealth 1.000
    ["mega"] = " m",  -- simpleHealth 1.000.000
    ["giga"] = " g",  -- simpleHealth 1.000.000.000
}

---------------------------------------------------
-- class specific configuration
---------------------------------------------------
if class == "PRIEST" then
    whoaUnitFrames.config.largeAuraSize = 27
    whoaUnitFrames.config.smallAuraSize = 21
    whoaUnitFrames.config.autoManaPercent = false
--    whoaUnitFrames.config.classColor = false
end
if class == "DRUID" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "MONK" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "MAGE" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "PALADIN" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "SHAMAN" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "WARLOCK" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "DEATHKNIGHT" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "HUNTER" then
    whoaUnitFrames.config.repositionPartyText = false
end
if class == "ROGUE" then
    whoaUnitFrames.config.autoManaPercent = false
end
if class == "WARRIOR" then
    whoaUnitFrames.config.repositionPartyText = false
end